;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;	Cognitive Model for Modelling of List Menus, Updates and Adaptations, Learning.
;;;	Please see model discription: 
;;;	Prezenski, S. and Russwinkel, N.(2016). Towards a General Model of Repeated App Usage. In D. Reitter & F. Ritter (Eds.), In Proc. of the 14th Int. ;;;Conference on Cognitive Modeling. Pennsylvania, USA.
;;;																					
;;;																					
;;; 								!WARNING: Paths have to be adjusted!									
;;; 													
;;;																					
;;;																					
;;;							Version  1									
;;;							 2016/06/10									
;;;					Copyright (C)  Sabine Prezenski	sabine.prezenski@tu-berlin.de			
;;;									
;;; 																				
;;;																					
;;;	To copy and/or distributed the file it is compulsary to cite:
;;; 	Prezenski, S. and Russwinkel, N.(2016). Towards a General Model of Repeated App Usage. In D. Reitter & F. Ritter (Eds.), In Proc. of the 14th Int. ;;;Conference on Cognitive Modeling. Pennsylvania, USA. 				
;;;	 			
;;;	 		
;;;						
;;;																					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(chunk-type property name object)
(chunk-type location object position)
;hier werden alle möglichen Assoziationen gespeichert
(chunk-type is-associated objects category)
;learned path
(chunk-type prodpath property count first second third fourth target-im)
;der Pfad soll aus dem semantischen Gedächtnis mit dem imaginal aufgebaut werden.

;fürs goal 
(chunk-type task state subtarget finaltarget target-meaning menudepthlist menudepth ImmoList errorpath)

;ein Log-Funktion
(defun log-item (item1 item2);item3?
	(with-open-file (f "immo-output.txt" :direction :output :if-exists :append :if-does-not-exist :create)
	(format f "~6,3F ~A ~A ~A~C~%" (mp-time) *version* item1 item2 #\return)));item3?

(add-dm

(goal isa task state start subtarget nil target-meaning nil finaltarget nil menudepth nil ImmoList ( "WGzimmer" "Haus" "750" "60m" "3bis4" "Wedding" "Rasen" "Haus" "Tempelhof" "60m" "3bis4" "750" "Rasen" "Einstellungen" "Mietwohnung" "750" "60m" "3bis4" "Neukoelln" "Rasen" "Mietwohnung" "Tiergarten" "750" "3bis4" "60m" "Rasen" "End" "Last") menudepthlist( four four three three three three threefour-two four three three three three threefour-two egal four three three three three threefour-two four three three three three threefour-two no no ))


;erste Seite (damit das Modell die Begriffe lesen kann)
(suchen isa property name "SUCHEN" object suchen)
(merkzettel isa property name "MERKZETTEL" object merkzettel)
(meineanzeigen isa property name "MEINEANZEIGEN" object meineanzeigen)
(einstellungen isa property name "EINSTELLUNGEN" object einstellungen)
(mietwohnung isa property name "MIETWOHNUNG" object mietwohnung)

;(s<< isa property name "<<" object s<<)
(was isa property name "WAS" object was)
(bezirk isa property name "BEZIRK" object bezirk)
(zimmer isa property name "ZIMMER" object Zimmer)
(flaeche isa property name "FLAECHE" object flaeche)
(preis isa property name "PREIS" object preis)
(weiteres isa property name "WEITERES" object weiteres)

(mieten isa property name "MIETEN" object mieten)
(kaufen isa property name "KAUFEN" object kaufen)

;(mietwohnung isa property name "MIETWOHNUNG" object mietwohnung)
(haus isa property name "HAUS" object haus)
(grundstueck isa property name "GRUNDSTUECK" object grundstueck)
(wohnenaufzeit isa property name "WOHNENAUFZEIT" object wohnenaufzeit)
(wgzimmer isa property name "WGZimmer" object wgzimmer)

(eigentumswohnung isa property name "eigentumswohnung" object eigentumswohnung)
(garagen isa property name "GARAGEN" object garagen)

(charlottenburg isa property name "charlottenburg" object charlottenburg)
(kreuzberg isa property name "kreuzberg" object kreuzberg)
(neukoelln isa property name "neukoelln" object neukoelln)
(tempelhof isa property name "tempelhof" object tempelhof)
(tiergarten isa property name "tiergarten" object tiergarten)
(wedding isa property name "wedding" object wedding)

(1bis2 isa property name "1bis2" object 1bis2)
(2bis3 isa property name "2bis3" object 2bis3)
(3bis4 isa property name "3bis4" object 3bis4)
(4bis5 isa property name "4bis5" object 4bis5)
(5bis6 isa property name "5bis6" object 5bis6)
(6plus isa property name "6plus" object 6plus)

(20m isa property name "20m" object 20m)
(30m isa property name "30m" object 30m)
(40m isa property name "40m" object 40m)
(50m isa property name "50m" object 50m)
(60m isa property name "60m" object 60m)
(70m isa property name "70m" object 70m)
(80m isa property name "80m" object 80m)
(90m isa property name "90m" object 90m)
(100m isa property name "100m+" object 100m)

(250z isa property name "250" object 250z)
(350z isa property name "350" object 350z)
(450z isa property name "450" object 450z)
(550z isa property name "550" object 550z)
(650z isa property name "650" object 650z)
(750z isa property name "750" object 750z)
(850z isa property name "850" object 850z)
(950z isa property name "950" object 950z)
(1050z isa property name "1050" object 1050z)

(Ausstattung isa property name "AUSSTATTUNG" object ausstattung)
(Wohnungstyp isa property name "WOHNUNGSTYP" object Wohnungstyp)
(Garten isa property name "GARTEN" object Garten)
(Rasen isa property name "RASEN" object Rasen)

;Nun braucht das Modell Weltwissen (assoziationschunks) um navigieren zu können:
;Mietwohnung
(zE isa is-associated objects einstellungen category einstellungen)

(z1 isa is-associated objects mietwohnung category suchen)
(z12 isa is-associated objects mietwohnung category was)
(z13 isa is-associated objects mietwohnung category mieten)
(z14 isa is-associated objects mietwohnung category mietwohnung); optional- für ein erstes Modell hilfreich

(z111 isa is-associated objects wgzimmer category suchen)
(z1112 isa is-associated objects wgzimmer category was)
(z1113 isa is-associated objects wgzimmer category mieten)
(z1114 isa is-associated objects wgzimmer category wgzimmer);

(z2 isa is-associated objects 750z category suchen)
(z22 isa is-associated objects 750z category Preis)
(z23 isa is-associated objects 750z category 750z)

(z3 isa is-associated objects 60m category suchen)
(z32 isa is-associated objects 60m category Flaeche)
(z33 isa is-associated objects 60m category 60m)

(z9 isa is-associated objects 3bis4 category suchen)
(z92 isa is-associated objects 3bis4 category Zimmer)
(z93 isa is-associated objects 3bis4 category 3bis4)

(z4 isa is-associated objects Neukoelln category suchen)
(z42 isa is-associated objects Neukoelln category Bezirk)
(z43 isa is-associated objects Neukoelln category Neukoelln)

(z5 isa is-associated objects Rasen category suchen)
(z52 isa is-associated objects Rasen category Weiteres)
(z53 isa is-associated objects Rasen category Garten)
(z54 isa is-associated objects Rasen category Rasen)

(z6 isa is-associated objects Tiergarten category suchen)
(z62 isa is-associated objects Tiergarten category Bezirk)
(z63 isa is-associated objects Tiergarten category Tiergarten)

(z7 isa is-associated objects Tempelhof category suchen)
(z72 isa is-associated objects Tempelhof category Bezirk)
(z73 isa is-associated objects Tempelhof category Tempelhof)

(z8 isa is-associated objects Wedding category suchen)
(z82 isa is-associated objects Wedding category Bezirk)
(z83 isa is-associated objects Wedding category Wedding)

(z10 isa is-associated objects Haus category suchen)
(z102 isa is-associated objects Haus category was)
(z103 isa is-associated objects Haus category mieten)
(z104 isa is-associated objects Haus category Haus)

(start isa chunk)
(count isa chunk)
(one isa chunk)
(lookingformeaning isa chunk)
(lookpath isa chunk)
(true isa chunk)
(two isa chunk)
(locationsearch isa chunk)
(three isa chunk)
(four isa chunk)
(moveclick isa chunk)
(click isa chunk)
(checking-matched isa chunk)
(visualsearch isa chunk)
(finding isa chunk)
(processing isa chunk)
(prepareclick isa chunk)
(checking-match isa chunk)
(found isa chunk)
(goback isa chunk)
(backing isa chunk)
(backing1 isa chunk)
(backing2 isa chunk)
(change-search isa chunk)
(back-since-wrong isa chunk)
(backing1-since-wrong isa chunk)
(backing2-since-wrong isa chunk)
(backing-since-wrong isa chunk)
(backerror isa chunk)
(scan isa chunk)
(scaning isa chunk)
(encoding isa chunk)
(fourthree-two isa chunk)
(threefour-two isa chunk)
(fourthree-three isa chunk)
(threefour-three isa chunk)

)
(sdp :creation-time -100000 :references 10000)


