;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;	Cognitive Model for Modelling of List Menus, Updates and Adaptations, Learning.
;;;	Please see model discription: 
;;;	Prezenski, S. and Russwinkel, N.(2016). Towards a General Model of Repeated App Usage. In D. Reitter & F. Ritter (Eds.), In Proc. of the 14th Int. ;;;Conference on Cognitive Modeling. Pennsylvania, USA.
;;;																					
;;;																					
;;; 								!WARNING: Paths have to be adjusted!									
;;; 													
;;;																					
;;;																					
;;;							Version  1									
;;;							 2016/06/10									
;;;					Copyright (C)  Sabine Prezenski	sabine.prezenski@tu-berlin.de			
;;;									
;;; 																				
;;;																					
;;;	To copy and/or distributed the file it is compulsary to cite:
;;; 	Prezenski, S. and Russwinkel, N.(2016). Towards a General Model of Repeated App Usage. In D. Reitter & F. Ritter (Eds.), In Proc. of the 14th Int. ;;;Conference on Cognitive Modeling. Pennsylvania, USA. 				
;;;	 			
;;;	 		
;;;						
;;;																					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(chunk-type property name object)
(chunk-type location object position)
;hier werden alle möglichen Assoziationen gespeichert
(chunk-type is-associated objects category)
;learned path
(chunk-type prodpath version property count first second third fourth target-im)
;der Pfad soll aus dem semantischen Gedächtnis mit dem imaginal aufgebaut werden.

;fürs goal 
(chunk-type task state subtarget finaltarget target-meaning menudepthlist menudepth ImmoList errorpath)
;(chunk-type task state version target current target-meaning ImmoList shoppingListB switchloc errorpath)

;ein Log-Funktion
(defun log-item (item1 item2);item3?
	(with-open-file (f "immo-output.txt" :direction :output :if-exists :append :if-does-not-exist :create)
	(format f "~6,3F ~A ~A ~A~C~%" (mp-time) *version* item1 item2 #\return)));item3?

(add-dm

(goal isa task state start subtarget nil target-meaning nil finaltarget nil menudepth nil ImmoList("alkoholfreiesbier" "dickmilch" "ananasdose" "duschgel" "amerikaner" "edamer" "altbier" "dorade" "acrylfarbeweiss" "alkoholfreiesbier" "dickmilch" "ananasdose" "duschgel" "amerikaner" "edamer" "altbier" "dorade" "acrylfarbeweiss" "einstellungen" "alkoholfreiesbier" "dickmilch" "ananasdose" "duschgel" "amerikaner" "edamer" "altbier" "dorade" "acrylfarbeweiss" "alkoholfreiesbier" "dickmilch" "ananasdose" "duschgel" "amerikaner" "edamer" "altbier" "dorade" "acrylfarbeweiss" "End" "Blank") menudepthlist( fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three fourthree-three no no ))

;erste Seite
(stores isa property name "laeden" object stores)
(versionbs isa property name "versionb" object versionb)
(versionas isa property name "versiona" object versiona)
(einstellungen isa property name "einstellungen" object einstellungen)

;Unterkategorien
(bier isa property name "bier" object bier)
(suessestueckchen isa property name "suessestueckchen" object suessestueckchen)
(milchprodukte isa property name "milchprodukte" object milchprodukte)
(konserven isa property name "konserven" object konserven)
(koerperpflege isa property name "koerperpflege"object koerperpflege)
(kaesetheke isa property name "kaesetheke" object kaesetheke)
(frischetheke isa property name "frischetheke" object frischetheke)
(malzubehoer isa property name "malzubehoer" object malzubehoer)

;Läden
(baeckerei isa property name "baeckerei" object baeckerei)
(drogerie isa property name "drogerie" object drogerie)
(frischefeinkost isa property name "frischefeinkost" object frischefeinkost)
(gemuesehaendler isa property name "gemuesehaendler" object gemuesehaendler)
(getraenke isa property name "getraenke" object getraenke)
(schreibwarenladen isa property name "schreibwarenladen" object schreibwarenladen)
(tanteemma isa property name "tanteemma" object tanteemma)

;Getränke
(alkoholfreiesbier isa property name "alkoholfreiesbier" object alkoholfreiesbier)
(altbier isa property name "altbier" object altbier)
(apfelsaft isa property name "apfelsaft" object apfelsaft)
(bananensaft isa property name "bananensaft" object bananensaft)
(bionade isa property name "bionade" object bionade)
(blutorangensaft isa property name "blutorangensaft" object blutorangensaft)
(champagnerextremt isa property name "champagnerextremt" object champagnerextremt)
(champagnersuess isa property name "champagnersuess" object champagnersuess)
(champagnertrocken isa property name "champagnertrocken" object champagnertrocken)
(cognac isa property name "cognac" object cognac)
(cola isa property name "cola" object cola)

(acrylfarbeweiss isa property name "acrylfarbeweiss" object acrylfarbeweiss)
(amerikaner isa property name "amerikaner" object amerikaner)
(ananasdose isa property name "ananasdose" object ananasdose)
(bananen isa property name "banane" object bananen)
(bierschinken isa property name "bierschinken" object bierschinken)
(biovollmilch isa property name "bio-vollmilch" object biovollmilch)
(dickmilch isa property name "dickmilch" object dickmilch)
(dorade isa property name "dorade" object dorade)
(duschgel isa property name "duschgel" object duschgel)
(edamer isa property name "edamer" object edamer)
(eiswuerfel isa property name "eiswuerfel" object eiswuerfel)
(erdbeereis isa property name "erdbeereis" object erdbeereis)
(erdbeequark isa property name "erdbeerquark" object erdbeequark)
(erdbeeryoghurt isa property name "erdbeeryoghurt" object erdbeeryoghurt)

(handcreme isa property name "handcreme" object handcreme)

(kartoffeln isa property name "kartoffeln" object kartoffeln)
(naturyoghurt isa property name "naturyoghurt" object naturyoghurt)
(nusstorte isa property name "nusstorte" object nusstorte)
(orangensaft isa property name "orangensaft" object orangensaft)

(pinsel isa property name "pinsel (duenn)" object pinsel) 

(schockoladeneis isa property name "schokoladeneis" object schockoladeneis)
(sprite isa property name "sprite" object sprite)

(weissbrot isa property name "weissbrot" object weissbrot)
;
(z0 isa is-associated objects einstellungen category einstellungen)
;alkoholfreies bier
(z1 isa is-associated objects alkoholfreiesbier category stores)
(z12 isa is-associated objects alkoholfreiesbier category getraenke)
(z13 isa is-associated objects alkoholfreiesbier category bier)
(z14 isa is-associated objects alkoholfreiesbier category alkoholfreiesbier)

;amerikaner
(z61 isa is-associated objects amerikaner category stores)
(z62 isa is-associated objects amerikaner category baeckerei)
(z63 isa is-associated objects amerikaner category suessestueckchen)
(z64 isa is-associated objects amerikaner category amerikaner)

;altbier
(z21 isa is-associated objects altbier category stores)
(z22 isa is-associated objects altbier category getraenke)
(z23 isa is-associated objects altbier category bier)
(z24 isa is-associated objects altbier category altbier)

;dickmilch
(z31 isa is-associated objects dickmilch category stores)
(z32 isa is-associated objects dickmilch category frischefeinkost)
(z33 isa is-associated objects dickmilch category milchprodukte)
(z34 isa is-associated objects dickmilch category dickmilch)

;ananasdose
(z41 isa is-associated objects ananasdose category stores)
(z42 isa is-associated objects ananasdose category tanteemma)
(z43 isa is-associated objects ananasdose category konserven)
(z44 isa is-associated objects ananasdose category ananasdose)

;duschgel
(z51 isa is-associated objects duschgel category stores)
(z52 isa is-associated objects duschgel category drogerie)
(z53 isa is-associated objects duschgel category koerperpflege)
(z54 isa is-associated objects duschgel category duschgel)

;edamer
(z91 isa is-associated objects edamer category stores)
(z92 isa is-associated objects edamer category frischefeinkost)
(z93 isa is-associated objects edamer category kaesetheke)
(z94 isa is-associated objects edamer category edamer)

;dorade
(z71 isa is-associated objects dorade category stores)
(z72 isa is-associated objects dorade category frischefeinkost)
(z73 isa is-associated objects dorade category frischetheke)
(z74 isa is-associated objects dorade category dorade)

;acrylfarbeweiss
(z81 isa is-associated objects acrylfarbeweiss category stores)
(z82 isa is-associated objects acrylfarbeweiss category schreibwarenladen)
(z83 isa is-associated objects acrylfarbeweiss category malzubehoer)
(z84 isa is-associated objects acrylfarbeweiss category acrylfarbeweiss)

(start isa chunk)
(count isa chunk)
(one isa chunk)
(lookingformeaning isa chunk)
(lookpath isa chunk)
(true isa chunk)
(two isa chunk)
(locationsearch isa chunk)
(three isa chunk)
(four isa chunk)
(moveclick isa chunk)
(click isa chunk)
(checking-matched isa chunk)
(visualsearch isa chunk)
(finding isa chunk)
(processing isa chunk)
(prepareclick isa chunk)
(checking-match isa chunk)
(found isa chunk)
(goback isa chunk)
(backing isa chunk)
(backing1 isa chunk)
(backing2 isa chunk)
(change-search isa chunk)
(back-since-wrong isa chunk)
(backing1-since-wrong isa chunk)
(backing2-since-wrong isa chunk)
(backing-since-wrong isa chunk)
(backerror isa chunk)
(scan isa chunk)
(scaning isa chunk)
(encoding isa chunk)
(versiona isa chunk)
(versionb isa chunk)
(fourthree-two isa chunk)
(threefour-two isa chunk)
(fourthree-three isa chunk)
(threefour-three isa chunk)

)
(sdp :creation-time -100000 :references 10000)


