;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;	Cognitive Model for Modelling of List Menus, Updates and Adaptations, Learning.
;;;	Please see model discription: 
;;;	Prezenski, S. and Russwinkel, N.(2016). Towards a General Model of Repeated App Usage. In D. Reitter & F. Ritter (Eds.), In Proc. of the 14th Int. ;;;Conference on Cognitive Modeling. Pennsylvania, USA.
;;;																					
;;;																					
;;; 								!WARNING: Paths have to be adjusted!									
;;; 													
;;;																					
;;;																					
;;;							Version  1									
;;;							 2016/06/10									
;;;					Copyright (C)  Sabine Prezenski	sabine.prezenski@tu-berlin.de			
;;;									
;;; 																				
;;;																					
;;;	To copy and/or distributed the file it is compulsary to cite:
;;; 	Prezenski, S. and Russwinkel, N.(2016). Towards a General Model of Repeated App Usage. In D. Reitter & F. Ritter (Eds.), In Proc. of the 14th Int. ;;;Conference on Cognitive Modeling. Pennsylvania, USA. 				
;;;	 			
;;;	 		
;;;						
;;;																					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(p start
 =goal> 
    isa         task
    state	    start 
	ImmoList =l 
	menudepthlist =t 
	finaltarget nil ;..
 !bind! =f (FIRST =l)
 !bind! =k (FIRST =t)
 ?imaginal>
    buffer empty
==>
  !bind! =sNew (REST =l)
  !bind! =kNew (REST =t)
 =goal>
    state count
    ImmoList =sNew
	menudepthlist =kNew
	finaltarget =f ;target as string
	menudepth =k
+retrieval> ;request for a chunk with the meaning of the target
	isa property
	name =f	
+imaginal>		;building up a path
	isa prodpath
!eval! (log-item "Start" =f)
)


(P meaning-in-goal
=goal>
	isa task
	state count
	finaltarget =f
	target-meaning nil
=retrieval> ;the meaning of the target has been retrieved
	isa property
	name =f	
	object =o ;the meaning of the target has been retrieved
=imaginal> 
	isa prodpath
	count nil 
==>
=goal>
	state lookingformeaning
	target-meaning =o ;the meaning-of the target is copied into the goal
=imaginal>
	target-im =o ;the meaning-of the target is copied into the imaginal
	count one ;change count to one
-retrieval>
)

(P look-for-path-not-ep 
=goal>
	isa task
	state lookingformeaning
	target-meaning =word ;target
	errorpath nil ;no errorpath
?visual>
	state free
==>
=goal>
	state lookpath
+retrieval>		;request a chunk that has the path leading to the target
	isa prodpath
	target-im =word
+visual-location> ;move visual attention to the top
	isa visual-location
	screen-y lowest 
+visual>
	isa clear 
)

(P look-for-path-ep-43-two-count2or3or4
=goal>
	isa task
	state lookingformeaning
	target-meaning =word
	menudepth fourthree-two
	errorpath true ; error in path
?visual>
	state free
=imaginal>
	isa prodpath
	- count one
==>
=goal>
	state lookpath
=imaginal>
+retrieval>
	isa prodpath
	target-im =word
	third =word ;where the target is third in the path
+visual-location> ;move visual attention to the top
	isa visual-location 
	screen-y lowest 
+visual>
	isa clear 
)

(P look-for-path-ep-43-three-count3or4
=goal>
	isa task
	state lookingformeaning
	target-meaning =word
	menudepth fourthree-three
	errorpath true ; error in path
?visual>
	state free
=imaginal>
	isa prodpath
	- count one
	- count two
==>
=goal>
	state lookpath
=imaginal>
+retrieval>
	isa prodpath
	target-im =word
	third =word ;where the target is third in the path
+visual-location> ;move visual attention to the top
	isa visual-location 
	screen-y lowest 
+visual>
	isa clear 
)

(P look-for-path-ep-34-two-count2or3or4
=goal>
	isa task
	state lookingformeaning
	target-meaning =word
	menudepth threefour-two
	errorpath true ; error in path
?visual>
	state free
=imaginal>
	isa prodpath
	- count one
==>
=goal>
	state lookpath
=imaginal>
+retrieval> ;request a chunk that has the path leading to the target
	isa prodpath
	target-im =word
	fourth =word ;where the target is fourth in the path
+visual-location> ;move visual attention to the top
	isa visual-location 
	screen-y lowest 
+visual>
	isa clear 
)

(P look-for-path-ep-34-three-count2or3or4
=goal>
	isa task
	state lookingformeaning
	target-meaning =word
	menudepth threefour-three
	errorpath true ; error in path
?visual>
	state free
=imaginal>
	isa prodpath
	- count one
==>
=goal>
	state lookpath
=imaginal>
+retrieval> ;request a chunk that has the path leading to the target
	isa prodpath
	target-im =word
	fourth =word ;where the target is fourth in the path
+visual-location> ;move visual attention to the top
	isa visual-location 
	screen-y lowest 
+visual>
	isa clear 
)

(P look-for-path-ep-34-43-two-count1 
=goal>
	isa task
	state lookingformeaning
	target-meaning =word
	- menudepth four
	- menudepth three
	- menudepth fourthree-three
	- menudepth threefour-three
	errorpath true ;error in path
?visual>
	state free
=imaginal>
- count two
- count three
- count four
==>
=imaginal>
=goal>
	state lookpath
+retrieval> ;request a chunk that has the path leading to the target
	isa prodpath
	target-im =word
+visual-location> ;move visual attention to the top
	isa visual-location 
	screen-y lowest 
+visual>
	isa clear 
)

(P look-for-path-ep-34-43-three-count1or2
=goal>
	isa task
	state lookingformeaning
	target-meaning =word
	- menudepth four
	- menudepth three
	- menudepth fourthree-two
	- menudepth threefour-two
	errorpath true ;error in path
?visual>
	state free
=imaginal>
- count three
- count four
==>
=imaginal>
=goal>
	state lookpath
+retrieval> ;request a chunk that has the path leading to the target
	isa prodpath
	target-im =word
+visual-location> ;move visual attention to the top
	isa visual-location 
	screen-y lowest 
+visual>
	isa clear 
)

(P look-for-path-ep
=goal>
	isa task
	state lookingformeaning
	target-meaning =word
	- menudepth fourthree-two
	- menudepth threefour-two
	- menudepth fourthree-three
	- menudepth threefour-three
	errorpath true ;error in path
?visual>
	state free
==>
=goal>
	state lookpath
+retrieval> ;request a chunk that has the path leading to the target
	isa prodpath
	target-im =word
+visual-location> ;move visual attention to the top
	isa visual-location 
	screen-y lowest 
+visual>
	isa clear 
)

(P found-that-prodpath-first
=goal>
	isa task
	state lookpath 
=imaginal>
	isa prodpath
	count one
=retrieval> ;a path chunk leading to the target is found
	isa prodpath
	first =word1
==>
=goal>
	state locationsearch 
=imaginal>
	count two ;the count in the imaginal is changed from one to two
	first =word1 ;the first word -meaning from the path chunk in the retrieval
				;is copied to the imaginal
+retrieval>
	isa property 
		object =word1) ;initiate a retrieval request for a chunk with the meaning and spelling
						;for the first word 
(P found-that-prodpath-second
=goal>
	isa task
	state lookpath 
=imaginal>
	isa prodpath
	count two
=retrieval> 	;a path chunk leading to the target is found
	isa prodpath
		second =word2
==>
=goal>
	state locationsearch 
=imaginal>
	count three ;the count in the imaginal is changed from two to three
	second =word2 ;the second word-meaning is copied 
+retrieval>
	isa property 
		object =word2) 	;initiate a retrieval request for a chunk with the meaning and spelling
						;for the secdond word 

(P found-that-prodpath-third
=goal>
	isa task
	state lookpath 
=imaginal>
	isa prodpath
	count three
=retrieval> ;a path chunk leading to the target is found
	isa prodpath
		third =word33
==>
=goal>
	state locationsearch
=imaginal>
	count four  ;the count in the imaginal is changed three to four
	third =word33 ;the third word-meaning is copied
+retrieval>
	isa property 
		object =word33 ;initiate a retrieval request for a chunk with the meaning and spelling
						;for the third word 
			) 

(P found-that-prodpath-fourth 
=goal>
	isa task
	state lookpath 
=imaginal>
	isa prodpath
	count four
=retrieval> ;a path chunk leading to the target is found
	isa prodpath
		fourth =word4
==>
=goal>
	state locationsearch
=imaginal>
	count four  ;the count in the imaginal is four
	fourth =word4 ;the fourth word-meaning is copied
+retrieval>
	isa property 
		object =word4 ;initiate a retrieval request for a chunk with the meaning and spelling
						;for the fourth word 
) 

(P find-location
=goal>
	isa task
	state locationsearch
=retrieval>
	isa property  ;a chunk with meaning (object) and spelling (names) of subtarget
	object =word
	name =names
==>
=goal>
	state locationsearch
	subtarget =names
+retrieval> ;request of a chunk with the location of the subtarget
	isa text
	value =names
)

(P found-location ;the subtarget-spelling is copied in the goal
=goal>
	isa task
	state locationsearch
=retrieval> ;a chunk with the retrieved location of the subtarget is found 
	isa text
	value =names
	screen-pos =pos
?visual>
	state free	
?manual>
	state free
 ==>
=goal>
	state moveclick
	;subtarget =names 		;the subtarget-spelling is copied in the goal
+visual>
	isa move-attention ;the visual attention is moved to the remembered location
	screen-pos =pos	
+manual>				;the manual is moved to the remembered location
	isa move-cursor
	loc =pos
	)

(P found-no-location 
	=goal>
	isa task
	state locationsearch
?retrieval> 
	state error
?visual>
	state free	
==>
-visual>
+visual-location>
	isa visual-location
	> screen-y lowest
	kind text
	screen-y lowest
=goal>
	state scan
	)

(P click-location
 =goal>
	 isa task
	state checking-matched
	finaltarget =f ;
	subtarget =g
 ?manual>
	 state free
 ==>
 +manual>
	 isa click-mouse
 =goal>
	 state click
!eval! (log-item "Click_loc" =f)
!eval! (log-item "Button" =g)
	 )
				
(P change-strategy 
=goal>
	isa task
	state lookpath 
	finaltarget =f 
?retrieval>
	state error ;no path could be retrieved
==>
=goal>
	state visualsearch
)
	
(P find-word
=goal>
	isa task 
	state visualsearch
?visual>
	state free
==>
+visual-location> 	;move visual-attention to the highest unattended spot
	isa visual-location
	> screen-y current
	- screen-y current
	kind text
	screen-y lowest
=goal>
	state finding
)

(P reading-word
=goal>
	isa task 
	state finding
=visual-location>
	isa visual-location
	kind text
?visual>
	state free
==>
+visual>				
	isa move-attention		;move attention to the location
	screen-pos =visual-location
=goal>
	state encoding
)

(P process-word-4 ;not for those with 3 layers
=goal>
	isa task
	state encoding
	- finaltarget =str	;if the finaltarget (the target) is not the same as the visual 
	menudepth four
=visual>
	isa text
	value =str
=imaginal>
	isa prodpath 
	 - count four
 ?retrieval>
	 state free
==>
=imaginal>
=visual>
+retrieval> ;retrieve the meaning and spelling of the target-word
	isa property
	name =str
=goal>
	state processing)
	
(P process-word-3 ;only when the count is not 4 or 3
=goal>
	isa task
	state encoding
	- finaltarget =str ;if the finaltarget (the target) is not the same as the visual 
	menudepth three
=visual>
	isa text
	value =str
=imaginal>
	isa prodpath ;only when the count is not 4 or 3
	 - count three
 ?retrieval>
	 state free
==>
=imaginal>
=visual>
+retrieval> ;retrieve the meaning and spelling of the target-word
	isa property
	name =str
=goal>
	state processing)

(P cantprocess-word
=goal>
	isa task
	state processing
?retrieval> ;no chunk (association)could be retrievd
	state error
=visual>
	isa text
==>
-visual>
=goal>
	state visualsearch)	
	
(P process-word-ep-true-43-two
=goal>
	isa task
	state encoding
	- finaltarget =str ;the finaltarget is not the same as the visual
	errorpath true 
	menudepth fourthree-two
	- menudepth four
	- menudepth three
	- menudepth threefour-three
	- menudepth threefour-two
	- menudepth fourthree-three
=visual>
	isa text
	value =str
=imaginal>
	isa prodpath
	- count four
	- count three ;(?)
 ?retrieval>
	 state free
==>
=imaginal>
=visual>
+retrieval> ;retrieve the meaning and spelling of the target-word
	isa property
	name =str
=goal>
	state processing)
	
(P process-word-ep-nil-43-two-or-three
=goal>
	isa task
	state encoding
	- finaltarget =str ;the finaltarget is not the same as the visual
	errorpath nil
	- menudepth four
	- menudepth three
	- menudepth threefour-three
	- menudepth threefour-two
	=visual>
	isa text
	value =str
=imaginal>
	isa prodpath
	- count four
 ?retrieval>
	 state free
==>
=imaginal>
=visual>
+retrieval> ;retrieve the meaning and spelling of the target-word
	isa property
	name =str
=goal>
	state processing)	
	

	

	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
(P process-word-ep-true-34-two-or-three ;
=goal>
	isa task
	state encoding
	- finaltarget =str ;the finaltarget is not the same as the visual
	errorpath true 
	- menudepth four
	- menudepth three
	- menudepth fourthree-three
	- menudepth fourthree-two
=visual>
	isa text
	value =str
=imaginal>
	isa prodpath
	- count four
 ?retrieval>
	 state free
==>
=imaginal>
=visual>
+retrieval> ;retrieve the meaning and spelling of the target-word
	isa property
	name =str
=goal>
	state processing)


	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
(P process-word-ep-nil-34-two-or-three
=goal>
	isa task
	state encoding
	- finaltarget =str ;the finaltarget is not the same as the visual
	errorpath nil
	- menudepth four
	- menudepth three
	- menudepth fourthree-three
	- menudepth fourthree-two
=visual>
	isa text
	value =str
=imaginal>
	isa prodpath
	- count three
 ?retrieval>
	 state free
==>
=imaginal>
=visual>
+retrieval> ;retrieve the meaning and spelling of the target-word
	isa property
	name =str
=goal>
	state processing)


	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	

(P process-word-einstellungen ;only for einstellungen (for model controll only)
=goal>
	isa task
	state encoding
	finaltarget "einstellungen"
=visual>
	isa text
	value =str
=imaginal>
	isa prodpath
	- count four
 ?retrieval>
	 state free
==>
=imaginal>
=visual>
+retrieval>
	isa property
	name =str
=goal>
	state processing)

(P process-word-last-page-correct-3p ;for count three
=goal>
	isa task
	state encoding
	finaltarget =val ;string holding the target
	target-meaning =t ;the meaning of the target
=visual>
	isa text
	value =val ;the word seen is the target
	screen-pos =pos ;the position of the word
=imaginal>
	isa prodpath
	count three
?manual>
	state free
==>
=goal>
	subtarget =val ;the subtarget-string is the target
	state prepareclick
=imaginal>
	third =t ;the meaning of the target is copied in the third slot path-chunk 
=visual>
+manual>
	isa move-cursor
	loc =pos) ;the manual is moved to the position of the word
	
(P process-word-last-page-wrong-3p ;for count three (not for those with four layers)
=goal>
	isa task
	state encoding
	finaltarget =val ;the string holding the target
	menudepth three
=visual>
	isa text
	- value =val ;the visual is not the same as the target
	screen-pos =pos
=imaginal>
	isa prodpath
	count three ;the count is three
==>
=imaginal>
-visual>
=goal>
	state visualsearch)		

(P process-word-last-page-wrong-4p ;for count three (not for those with four layers)
=goal>
	isa task
	state encoding
	finaltarget =val ;the string holding the target
	menudepth four
=visual>
	isa text
	- value =val ;the visual is not the same as the target
	screen-pos =pos
=imaginal>
	isa prodpath
	count four 
==>
=imaginal>
-visual>
=goal>
	state visualsearch)
	
(P process-word-last-page-wrong-3-4-two-or-three-ep-nil ;count 3 (not for four layers) and errorpath
=goal>
	isa task
	state encoding
	errorpath nil
	finaltarget =val ;the string holding the target
	- menudepth four
	- menudepth three
	- menudepth fourthree-three
	- menudepth fourthree-two
=visual>
	isa text
	- value =val  ;the visual is not the same as the target
	screen-pos =pos
=imaginal>
	isa prodpath
	count three
==>
=imaginal>
-visual>
=goal>
	state visualsearch)	


	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
(P process-word-last-page-wrong-3-4-two-or-three-ep-true ;count 3 (not for four layers) and errorpath
=goal>
	isa task
	state encoding
	errorpath true
	finaltarget =val ;the string holding the target
	- menudepth four
	- menudepth three
	- menudepth fourthree-three
	- menudepth fourthree-two
=visual>
	isa text
	- value =val  ;the visual is not the same as the target
	screen-pos =pos
=imaginal>
	isa prodpath
	count four
==>
=imaginal>
-visual>
=goal>
	state visualsearch)	


	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
(P process-word-last-page-wrong-4-3-two-or-three-ep-true 
=goal>
	isa task
	state encoding
	errorpath true
	finaltarget =val 
	- menudepth four
	- menudepth three
	- menudepth threefour-three
	- menudepth threefour-two
=visual>
	isa text
	- value =val  
	screen-pos =pos
=imaginal>
	isa prodpath
	count three
==>
=imaginal>
-visual>
=goal>
	state visualsearch)	
















	
	
(P process-word-last-page-wrong-4-3-two-or-three-ep-nil ;count 3 (not for four layers) and errorpath
=goal>
	isa task
	state encoding
	errorpath nil
	finaltarget =val ;the string holding the target
	- menudepth four
	- menudepth three
	- menudepth threefour-three
	- menudepth threefour-two
=visual>
	isa text
	- value =val  ;the visual is not the same as the target
	screen-pos =pos
=imaginal>
	isa prodpath
	count four
==>
=imaginal>
-visual>
=goal>
	state visualsearch)	


	
	
	
	
	
	
	
	
	
	
	
	
	
	
		
(P process-word-last-page-correct-4p ;count four
=goal>
	isa task
	state encoding
	finaltarget =val ;the string holding the target
	target-meaning =t ;the meaning of the target
=visual>
	isa text
	value =val ;visual is the target
	screen-pos =pos
=imaginal>
	isa prodpath
	count four
?manual>
	state free
==>
=goal>
	subtarget =val ;the subtarget is the target
	state prepareclick
=imaginal>
	fourth =t ;the target-meaning is fourth and copied to the path
=visual>
+manual>
	isa move-cursor
	loc =pos)

	
(P searching-association
=goal>
	isa task
	state processing
	target-meaning =obj ;the meaning of the target
=retrieval>
	isa property
	object =cat ;meaning and spelling of the finaltarget read chunk
=visual>
	isa text
==>
=visual>
+retrieval>
	isa is-associated ;search for an association chunk (current chunk and target)
	objects =obj
	category =cat
=goal>
	state checking-match)

(P asociation-found-1 ;an association chunk is found; count one
=goal>
	isa task
	state checking-match
=retrieval>
	isa is-associated	;an association chunk is found
	category =cat
=imaginal>
	isa prodpath
	count one
=visual>
	isa text
	value =str ;visual value
==>
=imaginal>
	first =cat ;the first word in the path is copied from the assocaition chunk
	count two ;count two
=visual>
=goal>
	state found
	subtarget =str ;the visual value (string) is copied to the subtargetslot
)

(P asociation-found-2 ;an association chunk is found; count two
=goal>
	isa task
	state checking-match
=retrieval> ;an association chunk is found
	isa is-associated	
	category =cat
=imaginal>
	isa prodpath
	count two
=visual>
	isa text
	value =str
==>
=imaginal>
	second =cat ;the second word in the path is copied from the assocaition chunk
	count three ;count three
=visual>
=goal>
	state found
	subtarget =str  ;the visual value (string) is copied to the subtargetslot
)

(P asociation-found-3
=goal>
	isa task
	state checking-match
=retrieval>
	isa is-associated	
	category =cat
=imaginal>
	isa prodpath
	count three
=visual>
	isa text
	value =str
==>
=imaginal>
	third =cat
	count four
=visual>
=goal>
	state found
	subtarget =str
)

(P no-asociation-found 
=goal>
	isa task
	state checking-match
?retrieval> ;no association chunk found
	state error
=visual>
isa text
==>
-visual>
=goal>
state visualsearch ;continue visual-search
)

(P prepare-click
=goal>
	isa task
	state found 
=visual>
	isa text
	screen-pos =loc
?manual>
	state free
==>
+manual>
	isa move-cursor
	loc =loc
=goal>
	state prepareclick
-visual>
)

(P click
=goal>
	isa task
	state prepareclick
	finaltarget =f
	subtarget =g
?manual>
	state free
==>
+manual>
	isa click-mouse
=goal>
	state click
	!eval! (log-item "Click" =f)
	!eval! (log-item "Button" =g)
	)
	
(P waiting-click ;wait until clicking is finished (model control)
 =goal>
	 isa task
	 state click
	 finaltarget =str ;the finaltarget (targetword) and tzarget (subtarget) are not the same
	 - subtarget =str
?manual>
	 state free
 ==>
 =goal>
	 state lookingformeaning
)

(P waiting-last-click
=goal>
	isa task
	state click
	finaltarget =str  ;the finaltarget (targetword) and tzarget (subtarget) are the same
	subtarget =str 
=imaginal>
	isa prodpath
	count =var 
?manual>
	state free
==>
=imaginal>
	count nil ;the count is reset
=goal>
	state goback
	!output! " BACK"
		!eval! (log-item "Found" =str)
-imaginal>		;the path is put into dm
)

(P go-back ;clicking back (model-control)
=goal>
	isa task
	state goback
?visual>
	state free
?manual>
	state free
==>
+visual-location>
	isa visual-location
	kind text
	screen-y lowest
	screen-x lowest
=goal>
	state backing)

(P backing ;clicking back (model-control)
=goal>
	isa task
	state backing
=visual-location>
	isa visual-location
	kind text
?visual>
	state free
==>
+visual>
	isa move-attention
	screen-pos =visual-location
=goal>
	state backing1
-visual-location> )
	
(P process-back ;clicking back (model-control)
=goal>
	isa task
	state backing1
=visual>
	isa text
	value "<<"
	screen-pos =loc
?manual>
	state free
==>
+manual>
	isa move-cursor
	loc =loc
=goal>
	state backing2)
	
(P wait-back ;clicking back (model-control)
=goal>
	isa task
	state backing2
?manual>
	state free
	==>
+manual>
	isa click-mouse
=goal>
	state goback)

(P back-error
 =goal>
	 isa task
	 state backing1
 =visual>
	isa text
	- value "<<"
 ==>
 =goal>
	 state start
	target-meaning nil
	subtarget nil
	finaltarget nil)
	 
 (P checking-match ;ehemals controll-vergleich
 =goal>
	 isa task
	 state moveclick
	 subtarget =cat ;3.3
 =visual>
	 isa text
	value =cat
==>
 =visual>
 =goal>
	 state checking-matched)
 
(P checking-no-match ;subtarget (retrieval) and currentin visual are not the same
 =goal>
	 isa task
	 state moveclick
	 subtarget =cat ;3.3
 =visual>
	 isa text
	- value =cat
==>
 =visual>
 =goal>
	 state change-search)
	 
(P checking-empty ;the visual buffer has failed (no text at this remembered location)
 =goal>
	 isa task
	 state moveclick
	 subtarget =cat ;3.3.
?visual>
		buffer failure
==>
 +visual>
 isa clear
 +visual-location> 
	isa visual-location 
	screen-y lowest
 =goal>
	errorpath true 
	state change-search)
	
(P go-back-wrong 
=goal>
	isa task
	state back-since-wrong
?manual>
	state free
==>
+visual-location>
	isa visual-location
	kind text
	screen-y lowest
	screen-x lowest
=goal>
	state backing-since-wrong)

(P backing-path-wrong
=goal>
	isa task
	state backing-since-wrong
=visual-location>
	isa visual-location
	kind text
?visual>
	state free
==>
+visual>
	isa move-attention
	screen-pos =visual-location
=goal>
	state backing1-since-wrong
-visual-location> )
	
(P process-back-path-wrong
=goal>
	isa task
	state backing1-since-wrong
=visual>
	isa text
	value "<<"
	screen-pos =loc
?manual>
	state free
==>
+manual>
	isa move-cursor
	loc =loc
=goal>
	state backing2-since-wrong)
	
(P wait-back-path-wrong
=goal>
	isa task
	state backing2-since-wrong
?manual>
	state free
	==>
+manual>
	isa click-mouse
=goal>
	state backerror)

(P error-in-path-2
=goal>
	isa task
	state scan
=imaginal>
	isa prodpath
	count three
	second =word 
?visual-location>
	buffer failure
?visual> 
	buffer empty 
==>
=goal>
	state visualsearch
	errorpath true
=imaginal>
	second nil
	count two
 +visual>
 isa clear
)
	
(P error-in-path-3 ; TESTEN
=goal>
	isa task
	state scan
=imaginal>
	isa prodpath
	count four
?visual-location>
	buffer failure
?visual> 
	buffer empty 
==>
=goal>
	state visualsearch
	errorpath true
=imaginal>
	third nil
	count three
+visual>
	isa clear
)

(P prepare-wait
=goal>
isa task
state backerror
?manual>
state free
==>
=goal>
state visualsearch)
	
(P read-top-to-bottum-again
=goal> 
isa task
state change-search
subtarget =cat
=visual>
	 isa text
	- value =cat
==>
-visual>
+visual-location> ;move attention to the top
	isa visual-location
	> screen-y lowest
	kind text
	screen-y lowest
=goal>
	state scan
)

 (P go-back-error-in-path-43-two
=goal>
	errorpath true
	state change-search
	menudepth fourthree-two ;A more general model should use a diffrent slot in the goal buffer
=imaginal>
	isa prodpath
	count four
	third =value
==>
=goal>
	state back-since-wrong
=imaginal>
	count two
	second nil
	third nil
-visual>
	)

(P read-top-to-bottum-again-2 ;In search for the subtarget from retrieval 
=goal> 
	isa task
	state change-search
	subtarget =cat
	- menudepth fourthree-two
?visual>	;visual buffer is empty
buffer empty
==>
-visual> 
+visual-location> ;move attention to the top
	isa visual-location
	> screen-y lowest
	kind text
	screen-y lowest
=goal>
	state scan
)

(P scan-1 ;encode the visual location; In search for the subtarget from retrieval 
=goal>
	isa task
	state scan
	subtarget =cat
=visual-location>
	isa visual-location
	kind text
?visual>
	state free
==> 
+visual>
	isa move-attention
	screen-pos =visual-location
=visual-location>
=goal>
	state scaning
)

(P scan-correct ;visual and retrieval are the same, ;In search for the subtarget from retrieval 
=goal> 
	isa task
	state scaning
	subtarget =cat
=visual>
	isa text
	value =cat
==>
=goal>
state found
=visual>
)


(P scan-incorrect ;visual and retrieval are not the same ;In search for the subtarget from retrieval 
=goal> 
	isa task
	state scaning
	- subtarget =cat
=visual>
	isa text
	value =cat
==>
-visual>
+visual-location>
	isa visual-location
	> screen-y current
	- screen-y current
	kind text
	screen-y lowest
=goal>
	state scan)
	
(P scan-path-wrong-4-3
=goal> 
	isa task
	state scaning
	- subtarget =cat
	finaltarget =cat
	target-meaning =x
=visual>
	isa text
	value =cat
=imaginal>
	isa prodpath
	count four
	third =word
==>
=goal>
errorpath true
	subtarget =cat
	state encoding
=visual>
=imaginal>
	count three
	third =x
	)

 (P end ;ends the model
 =goal> 
	 isa task
	 state count
	 finaltarget "END"
 ==>
	 !output! "END"
 -goal>)