;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;	Cognitive Model for Modelling of List Menus, Updates and Adaptations, Learning.
;;;	Please see model discription: 
;;;	Prezenski, S. and Russwinkel, N.(2016). Towards a General Model of Repeated App Usage. In D. Reitter & F. Ritter (Eds.), In Proc. of the 14th Int. ;;;Conference on Cognitive Modeling. Pennsylvania, USA.
;;;																					
;;;																					
;;; 								!WARNING: Paths have to be adjusted!									
;;; 													
;;;																					
;;;																					
;;;							Version  1									
;;;							 2016/06/10									
;;;					Copyright (C)  Sabine Prezenski	sabine.prezenski@tu-berlin.de			
;;;									
;;; 																				
;;;																					
;;;	To copy and/or distributed the file it is compulsary to cite:
;;; 	Prezenski, S. and Russwinkel, N.(2016). Towards a General Model of Repeated App Usage. In D. Reitter & F. Ritter (Eds.), In Proc. of the 14th Int. ;;;Conference on Cognitive Modeling. Pennsylvania, USA. 				
;;;	 			
;;;	 		
;;;						
;;;																					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defvar *mypath* "C:/Users/Sabine/Desktop/ACT-R 7 Standalone/test/")

(load (concatenate 'string *mypath* "gui34_shopping.lsp"))

(defun do-experiment (who)

  (if (eq who 'human)
      (setf *visible* t)
    (setf *visible* nil))
  
  (build-display)
  (install-device *experiment-window*)
  
  (if (eq who 'human)
      (wait-for-human)
    (progn
      (proc-display :clear t)
      (run 1000))))

(defun wait-for-human ()
  (while (not *done*)
    (allow-event-manager *experiment-window*))
  (sleep 1))

(defun app (&optional who)
   (let ((result nil))
     (reset)
     (do-experiment who))
)

(clear-all)

(define-model AppModell
(sgp :v t :esc t :egs 3 :show-focus t :ul nil :visual-num-finsts 7 :visual-finst-span 10 :lf 0.05 :rt -2 :bll .5 :ncnar t :ans 0.3 :imaginal-activation 1 :mas 3) 
(load (concatenate 'string *mypath* "Knowledge_shopping_34.lsp"))
(load (concatenate 'string *mypath* "Model.lsp"))


(start-hand-at-mouse)
(goal-focus goal)
)

